// Generated by CoffeeScript 1.8.0
var PropTypes, PureRenderMixin, React, objectAssign, raf;

React = require('react');

objectAssign = require('react/lib/Object.assign');

PureRenderMixin = require('react/addons').addons.PureRenderMixin;

raf = require('raf');

PropTypes = React.PropTypes;

module.exports = React.createClass({
  displayName: 'Headroom',
  mixins: [PureRenderMixin],
  currentScrollY: 0,
  lastKnownScrollY: 0,
  ticking: false,
  propTypes: {
    children: PropTypes.any.isRequired,
    disableInlineStyles: PropTypes.bool,
    disable: PropTypes.bool,
    upTolerance: PropTypes.number,
    downTolerance: PropTypes.number,
    offset: PropTypes.number,
    onPin: PropTypes.func,
    onUnpin: PropTypes.func
  },
  getDefaultProps: function() {
    return {
      disableInlineStyles: false,
      disable: false,
      upTolerance: 20,
      downTolerance: 10,
      offset: 100,
      onPin: function() {},
      onUnpin: function() {}
    };
  },
  getInitialState: function() {
    return {
      pinned: true,
      translateY: 0,
      className: 'headroom headroom--pinned'
    };
  },
  componentDidMount: function() {
    if (!this.props.disable) {
      return this.eventListener = window.addEventListener('scroll', this.handleScroll, false);
    }
  },
  componentWillReceiveProps: function(nextProps) {
    if (nextProps.disable) {
      this.setState({
        translateY: 0,
        className: "headroom headroom--pinned",
        pinned: true
      });
      if (this.eventListener) {
        return window.removeEventListener('scroll', this.handleScroll);
      }
    }
  },
  handleScroll: function() {
    if (!this.ticking) {
      return raf(this.update);
    }
  },
  unpin: function() {
    if (this.state.pinned) {
      this.props.onUnpin();
    }
    return this.setState({
      translateY: "-100%",
      className: "headroom headroom--unpinned",
      pinned: false
    });
  },
  pin: function() {
    if (!this.state.pinned) {
      this.props.onPin();
    }
    return this.setState({
      translateY: 0,
      className: "headroom headroom--pinned",
      pinned: true
    });
  },
  update: function() {
    var distanceScrolled, scrollDirection;
    this.currentScrollY = this.getScrollY();
    scrollDirection = this.currentScrollY > this.lastKnownScrollY ? "down" : "up";
    distanceScrolled = Math.abs(this.currentScrollY - this.lastKnownScrollY);
    if (scrollDirection === "down" && this.currentScrollY > this.props.offset && distanceScrolled > this.props.downTolerance) {
      this.unpin();
    } else if (scrollDirection === "up" && distanceScrolled > this.props.upTolerance || this.currentScrollY < this.props.offset) {
      this.pin();
    }
    this.lastKnownScrollY = this.currentScrollY;
    return this.ticking = false;
  },
  getScrollY: function() {
    if (window.pageYOffset !== void 0) {
      return window.pageYOffset;
    } else if (window.scrollTop !== void 0) {
      return window.scrollTop;
    } else {
      return (document.documentElement || document.body.parentNode || document.body).scrollTop;
    }
  },
  render: function() {
    var style;
    style = {
      position: this.props.disable ? 'absolute' : 'fixed',
      left: 0,
      right: 0,
      top: 0,
      zIndex: 1,
      webkitTransform: "translateY(" + this.state.translateY + ")",
      msTransform: "translateY(" + this.state.translateY + ")",
      transform: "translateY(" + this.state.translateY + ")",
      webkitTransition: "all .25s ease-in-out",
      mozTransition: "all .25s ease-in-out",
      oTransition: "all .25s ease-in-out",
      transition: "all .25s ease-in-out"
    };
    if (!this.props.disableInlineStyles) {
      style = objectAssign(style, this.props.style);
    } else {
      style = this.props.style;
    }
    return React.createElement("div", React.__spread({}, this.props, {
      "style": style,
      "className": this.state.className
    }), this.props.children);
  }
});
